<template>
  <div id="app">
    <HeaderComponent />
    <Modal :show="show" @close-modal="closeModal">
      <Progressbar :currentQuestion="currentQuestion" />
      <Questionnaire
        :questions="questions"
        :currentQuestion="currentQuestion"
        v-on:handle-change="handleChange"
        v-on:handle-input="handleInput"
        v-on:handle-click="nextQuestion"
      />
    </Modal>
  </div>
</template>

<script>
import HeaderComponent from "@/components/HeaderComponent";
import Questionnaire from "@/components/Questionnaire";
import Progressbar from "@/components/Progressbar";
import Modal from "@/components/Modal";
import axios from "axios";

export default {
  name: "App",
  data() {
    return {
      questions: [],
      currentQuestion: 1,
      show: false,
    };
  },
  components: {
    HeaderComponent,
    Questionnaire,
    Progressbar,
    Modal,
  },
  created() {
    if (!localStorage.getItem("passed")) {
      axios
        .get("questions.json")
        .then((res) => {
          this.questions = res.data;
          setTimeout(() => (this.show = true), 1000);
        })
        .catch((e) => {
          console.error(e);
        });
    }

    return;
  },
  computed: {},
  methods: {
    closeModal() {
      localStorage.setItem("passed", 1);
      
      return (this.show = false);
    },
    sumbitData() {
      // submit on server
      // axios
      //   .post("/server-route", this.questions)
      //   .then(function (response) {
      //     console.log(response);
      //   })
      //   .catch(function (error) {
      //     console.log(error);
      //   });

      localStorage.setItem("passed", 1);

      this.show = false;
    },
    nextQuestion() {
      const index = this.currentQuestion - 1;

      if (index == this.questions.length - 1) {
        this.sumbitData();
      } else if (this.questions[index].value.length > 0) {
        if (
          index == 1 &&
          this.questions[index].value == this.questions[index].answers[0]
        ) {
          this.currentQuestion += 2;
        } else {
          this.currentQuestion++;
        }
      }

      return;
    },
    handleChange($e) {
      const question = this.questions[this.currentQuestion - 1];

      if (question.type == "textarea") {
        question.value == "off"
          ? (question.value = "")
          : (question.value = "off");
      } else if (question.type == "checkbox") {
        const index = question.value.indexOf($e.target.value);

        if (index === -1) {
          question.value.push($e.target.value);
        } else {
          question.value.splice(index, 1);
        }
      } else {
        question.value = $e.target.value;
      }
    },
    handleInput($e) {
      const question = this.questions[this.currentQuestion - 1];

      if (question.type == "checkbox") {
        question.comment = $e.target.value;
      } else {
        question.value = $e.target.value;
      }
    },
  },
};
</script>

<style lang="scss">
@import url("https://fonts.googleapis.com/css2?family=Roboto+Mono:wght@400;500;700&display=swap");

html {
  box-sizing: border-box;
}
body {
  margin: 0;
  padding: 0;
  box-sizing: inherit;
}
#app {
  color: #000;
  font-weight: 400;
  font-family: "Roboto Mono", sans-serif;
  box-sizing: inherit;
}
.container {
  width: 100%;
  margin: 0 auto;
  padding-left: 15px;
  padding-right: 15px;
  max-width: 1140px;
  box-sizing: inherit;
}
</style>
